unit agenda_appoint;

interface

uses
  System.Drawing, System.Collections, System.ComponentModel,
  System.Windows.Forms, System.Data, System.Data.OleDb, System.Resources;

type
  Tagenda_appoint = class(System.Windows.Forms.Form)
  {$REGION 'Designer Managed Code'}
  strict private
    /// <summary>
    /// Required designer variable.
    /// </summary>
    components: System.ComponentModel.IContainer;
    Paneldetail: System.Windows.Forms.Panel;
    l_email: System.Windows.Forms.Label;
    Label16: System.Windows.Forms.Label;
    l_mobile: System.Windows.Forms.Label;
    Label14: System.Windows.Forms.Label;
    l_phone: System.Windows.Forms.Label;
    Label12: System.Windows.Forms.Label;
    l_city: System.Windows.Forms.Label;
    Label10: System.Windows.Forms.Label;
    Label7: System.Windows.Forms.Label;
    Label8: System.Windows.Forms.Label;
    l_father: System.Windows.Forms.Label;
    Label6: System.Windows.Forms.Label;
    l_first: System.Windows.Forms.Label;
    Label4: System.Windows.Forms.Label;
    l_name: System.Windows.Forms.Label;
    Label2: System.Windows.Forms.Label;
    ldetail: System.Windows.Forms.Label;
    OleDbConnection1: System.Data.OleDb.OleDbConnection;
    Panelinter: System.Windows.Forms.Panel;
    ImageList1: System.Windows.Forms.ImageList;
    Paneldata: System.Windows.Forms.Panel;
    txtname: System.Windows.Forms.TextBox;
    txtfirst_father: System.Windows.Forms.TextBox;
    cmbbookid: System.Windows.Forms.ComboBox;
    txtbookid: System.Windows.Forms.TextBox;
    Btndetail: System.Windows.Forms.Button;
    cmbfirst_father: System.Windows.Forms.ComboBox;
    lfirst: System.Windows.Forms.Label;
    lname: System.Windows.Forms.Label;
    cmbname: System.Windows.Forms.ComboBox;
    txttime: System.Windows.Forms.TextBox;
    txtdescription: System.Windows.Forms.TextBox;
    ltime: System.Windows.Forms.Label;
    ldate: System.Windows.Forms.Label;
    ImageList2: System.Windows.Forms.ImageList;
    DateTimePicker1: System.Windows.Forms.DateTimePicker;
    ldescription: System.Windows.Forms.Label;
    btn_cancel: System.Windows.Forms.Button;
    btn_ok: System.Windows.Forms.Button;
    Btntime: System.Windows.Forms.Button;
    /// <summary>
    /// Required method for Designer support - do not modify
    /// the contents of this method with the code editor.
    /// </summary>
    procedure InitializeComponent;
    procedure Tagenda_appoint_Load(sender: System.Object; e: System.EventArgs);
    procedure cmbname_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure cmbfirst_father_SelectedIndexChanged(sender: System.Object; e: System.EventArgs);
    procedure Btndetail_Click(sender: System.Object; e: System.EventArgs);
    procedure Btntime_Click(sender: System.Object; e: System.EventArgs);
    procedure txtdescription_KeyPress(sender: System.Object; e: System.Windows.Forms.KeyPressEventArgs);
    procedure Tagenda_appoint_Activated(sender: System.Object; e: System.EventArgs);
    procedure btn_ok_Click(sender: System.Object; e: System.EventArgs);
    procedure btn_cancel_Click(sender: System.Object; e: System.EventArgs);
  {$ENDREGION}
  strict protected
    /// <summary>
    /// Clean up any resources being used.
    /// </summary>
    procedure Dispose(Disposing: Boolean); override;
  private
    { Private Declarations }
     procedure sub_nullovalue;
     procedure sub_info(bval: Boolean);
     procedure sub_load(v_field: string; v_fieldname: string);
     procedure sub_timeok;
     procedure sub_Btn_ok;
     procedure sub_Full(v_entry_type: string ; v_date: System.DateTime);
     procedure sub_cancel;
  public
    constructor Create;
     class function Showagenda_appoint: System.Windows.Forms.DialogResult;
     class function appoint_flag: Boolean;
     class function appoint_agenda_desc: string;
     class function appoint_agenda_time: string;
     class function appoint_agenda_date: System.DateTime;
     class function appoint_agenda_bookid: string;

		 class function appoint_left: Integer;
		 class function appointtxttime_Left: Integer;
		 class function appoint_Top: Integer;
		 class function appointtxttime_Top: Integer;
		 class function appointtxttime_Height: Integer;
  
  end;

  [assembly: RuntimeRequiredAttribute(TypeOf(Tagenda_appoint))]

implementation
 uses
 mainform, agenda, agenda_time;
 var

 vselect: System.Data.OleDb.OleDbCommand;
 vda: System.Data.OleDb.OleDbDataAdapter;
 vdset: System.Data.DataSet;

time_flag: Boolean;
v_appoint_flag: Boolean;
v_appoint_agenda_desc: string;
v_appoint_agenda_time: string;
v_appoint_agenda_date: System.DateTime;
v_appoint_agenda_bookid: string;

v_appoint_left: Integer;
v_appoint_txttimeLeft: Integer;
v_appoint_Top: Integer;
v_appoint_txttimeTop: Integer;
v_appoint_txttimeHeight: Integer;


{$REGION 'Windows Form Designer generated code'}
/// <summary>
/// Required method for Designer support -- do not modify
/// the contents of this method with the code editor.
/// </summary>
procedure Tagenda_appoint.InitializeComponent;
var
  resources: System.Resources.ResourceManager;
begin
  Self.components := System.ComponentModel.Container.Create;
  resources := System.Resources.ResourceManager.Create(TypeOf(Tagenda_appoint));
  Self.Paneldetail := System.Windows.Forms.Panel.Create;
  Self.l_email := System.Windows.Forms.Label.Create;
  Self.Label16 := System.Windows.Forms.Label.Create;
  Self.l_mobile := System.Windows.Forms.Label.Create;
  Self.Label14 := System.Windows.Forms.Label.Create;
  Self.l_phone := System.Windows.Forms.Label.Create;
  Self.Label12 := System.Windows.Forms.Label.Create;
  Self.l_city := System.Windows.Forms.Label.Create;
  Self.Label10 := System.Windows.Forms.Label.Create;
  Self.Label7 := System.Windows.Forms.Label.Create;
  Self.Label8 := System.Windows.Forms.Label.Create;
  Self.l_father := System.Windows.Forms.Label.Create;
  Self.Label6 := System.Windows.Forms.Label.Create;
  Self.l_first := System.Windows.Forms.Label.Create;
  Self.Label4 := System.Windows.Forms.Label.Create;
  Self.l_name := System.Windows.Forms.Label.Create;
  Self.Label2 := System.Windows.Forms.Label.Create;
  Self.ldetail := System.Windows.Forms.Label.Create;
  Self.OleDbConnection1 := System.Data.OleDb.OleDbConnection.Create;
  Self.Panelinter := System.Windows.Forms.Panel.Create;
  Self.ImageList1 := System.Windows.Forms.ImageList.Create(Self.components);
  Self.Paneldata := System.Windows.Forms.Panel.Create;
  Self.txtname := System.Windows.Forms.TextBox.Create;
  Self.txtfirst_father := System.Windows.Forms.TextBox.Create;
  Self.cmbbookid := System.Windows.Forms.ComboBox.Create;
  Self.txtbookid := System.Windows.Forms.TextBox.Create;
  Self.Btndetail := System.Windows.Forms.Button.Create;
  Self.cmbfirst_father := System.Windows.Forms.ComboBox.Create;
  Self.lfirst := System.Windows.Forms.Label.Create;
  Self.lname := System.Windows.Forms.Label.Create;
  Self.cmbname := System.Windows.Forms.ComboBox.Create;
  Self.txttime := System.Windows.Forms.TextBox.Create;
  Self.txtdescription := System.Windows.Forms.TextBox.Create;
  Self.ltime := System.Windows.Forms.Label.Create;
  Self.ldate := System.Windows.Forms.Label.Create;
  Self.ImageList2 := System.Windows.Forms.ImageList.Create(Self.components);
  Self.DateTimePicker1 := System.Windows.Forms.DateTimePicker.Create;
  Self.ldescription := System.Windows.Forms.Label.Create;
  Self.btn_cancel := System.Windows.Forms.Button.Create;
  Self.btn_ok := System.Windows.Forms.Button.Create;
  Self.Btntime := System.Windows.Forms.Button.Create;
  Self.Paneldetail.SuspendLayout;
  Self.Paneldata.SuspendLayout;
  Self.SuspendLayout;
  // 
  // Paneldetail
  // 
  Self.Paneldetail.BackColor := System.Drawing.SystemColors.ControlDark;
  Self.Paneldetail.Controls.Add(Self.l_email);
  Self.Paneldetail.Controls.Add(Self.Label16);
  Self.Paneldetail.Controls.Add(Self.l_mobile);
  Self.Paneldetail.Controls.Add(Self.Label14);
  Self.Paneldetail.Controls.Add(Self.l_phone);
  Self.Paneldetail.Controls.Add(Self.Label12);
  Self.Paneldetail.Controls.Add(Self.l_city);
  Self.Paneldetail.Controls.Add(Self.Label10);
  Self.Paneldetail.Controls.Add(Self.Label7);
  Self.Paneldetail.Controls.Add(Self.Label8);
  Self.Paneldetail.Controls.Add(Self.l_father);
  Self.Paneldetail.Controls.Add(Self.Label6);
  Self.Paneldetail.Controls.Add(Self.l_first);
  Self.Paneldetail.Controls.Add(Self.Label4);
  Self.Paneldetail.Controls.Add(Self.l_name);
  Self.Paneldetail.Controls.Add(Self.Label2);
  Self.Paneldetail.Controls.Add(Self.ldetail);
  Self.Paneldetail.Location := System.Drawing.Point.Create(424, 8);
  Self.Paneldetail.Name := 'Paneldetail';
  Self.Paneldetail.Size := System.Drawing.Size.Create(200, 184);
  Self.Paneldetail.TabIndex := 56;
  // 
  // l_email
  // 
  Self.l_email.Location := System.Drawing.Point.Create(60, 160);
  Self.l_email.Name := 'l_email';
  Self.l_email.Size := System.Drawing.Size.Create(128, 14);
  Self.l_email.TabIndex := 16;
  Self.l_email.Text := 'email';
  // 
  // Label16
  // 
  Self.Label16.ForeColor := System.Drawing.SystemColors.ControlLight;
  Self.Label16.Location := System.Drawing.Point.Create(12, 160);
  Self.Label16.Name := 'Label16';
  Self.Label16.Size := System.Drawing.Size.Create(40, 14);
  Self.Label16.TabIndex := 15;
  Self.Label16.Text := 'email';
  // 
  // l_mobile
  // 
  Self.l_mobile.Location := System.Drawing.Point.Create(60, 136);
  Self.l_mobile.Name := 'l_mobile';
  Self.l_mobile.Size := System.Drawing.Size.Create(128, 14);
  Self.l_mobile.TabIndex := 14;
  Self.l_mobile.Text := 'mobile';
  // 
  // Label14
  // 
  Self.Label14.ForeColor := System.Drawing.SystemColors.ControlLight;
  Self.Label14.Location := System.Drawing.Point.Create(12, 136);
  Self.Label14.Name := 'Label14';
  Self.Label14.Size := System.Drawing.Size.Create(40, 14);
  Self.Label14.TabIndex := 13;
  Self.Label14.Text := 'mobile';
  // 
  // l_phone
  // 
  Self.l_phone.Location := System.Drawing.Point.Create(60, 112);
  Self.l_phone.Name := 'l_phone';
  Self.l_phone.Size := System.Drawing.Size.Create(128, 14);
  Self.l_phone.TabIndex := 12;
  Self.l_phone.Text := 'phone';
  // 
  // Label12
  // 
  Self.Label12.ForeColor := System.Drawing.SystemColors.ControlLight;
  Self.Label12.Location := System.Drawing.Point.Create(12, 112);
  Self.Label12.Name := 'Label12';
  Self.Label12.Size := System.Drawing.Size.Create(40, 14);
  Self.Label12.TabIndex := 11;
  Self.Label12.Text := 'phone';
  // 
  // l_city
  // 
  Self.l_city.Location := System.Drawing.Point.Create(56, 85);
  Self.l_city.Name := 'l_city';
  Self.l_city.Size := System.Drawing.Size.Create(128, 14);
  Self.l_city.TabIndex := 10;
  Self.l_city.Text := 'city ';
  // 
  // Label10
  // 
  Self.Label10.ForeColor := System.Drawing.SystemColors.ControlLight;
  Self.Label10.Location := System.Drawing.Point.Create(8, 85);
  Self.Label10.Name := 'Label10';
  Self.Label10.Size := System.Drawing.Size.Create(40, 14);
  Self.Label10.TabIndex := 9;
  Self.Label10.Text := 'city ';
  // 
  // Label7
  // 
  Self.Label7.Location := System.Drawing.Point.Create(60, 88);
  Self.Label7.Name := 'Label7';
  Self.Label7.Size := System.Drawing.Size.Create(128, 14);
  Self.Label7.TabIndex := 8;
  Self.Label7.Text := 'n';
  // 
  // Label8
  // 
  Self.Label8.ForeColor := System.Drawing.SystemColors.ControlLight;
  Self.Label8.Location := System.Drawing.Point.Create(12, 88);
  Self.Label8.Name := 'Label8';
  Self.Label8.Size := System.Drawing.Size.Create(40, 14);
  Self.Label8.TabIndex := 7;
  Self.Label8.Text := 'L';
  // 
  // l_father
  // 
  Self.l_father.Location := System.Drawing.Point.Create(56, 64);
  Self.l_father.Name := 'l_father';
  Self.l_father.Size := System.Drawing.Size.Create(128, 14);
  Self.l_father.TabIndex := 6;
  Self.l_father.Text := 'father ';
  // 
  // Label6
  // 
  Self.Label6.ForeColor := System.Drawing.SystemColors.ControlLight;
  Self.Label6.Location := System.Drawing.Point.Create(8, 64);
  Self.Label6.Name := 'Label6';
  Self.Label6.Size := System.Drawing.Size.Create(40, 14);
  Self.Label6.TabIndex := 5;
  Self.Label6.Text := 'father ';
  // 
  // l_first
  // 
  Self.l_first.Location := System.Drawing.Point.Create(56, 40);
  Self.l_first.Name := 'l_first';
  Self.l_first.Size := System.Drawing.Size.Create(128, 14);
  Self.l_first.TabIndex := 4;
  Self.l_first.Text := 'first';
  // 
  // Label4
  // 
  Self.Label4.ForeColor := System.Drawing.SystemColors.ControlLight;
  Self.Label4.Location := System.Drawing.Point.Create(8, 40);
  Self.Label4.Name := 'Label4';
  Self.Label4.Size := System.Drawing.Size.Create(40, 14);
  Self.Label4.TabIndex := 3;
  Self.Label4.Text := 'first';
  // 
  // l_name
  // 
  Self.l_name.Location := System.Drawing.Point.Create(56, 16);
  Self.l_name.Name := 'l_name';
  Self.l_name.Size := System.Drawing.Size.Create(128, 14);
  Self.l_name.TabIndex := 2;
  Self.l_name.Text := 'name';
  // 
  // Label2
  // 
  Self.Label2.ForeColor := System.Drawing.SystemColors.ControlLight;
  Self.Label2.Location := System.Drawing.Point.Create(8, 16);
  Self.Label2.Name := 'Label2';
  Self.Label2.Size := System.Drawing.Size.Create(40, 14);
  Self.Label2.TabIndex := 1;
  Self.Label2.Text := 'name';
  // 
  // ldetail
  // 
  Self.ldetail.Font := System.Drawing.Font.Create('Microsoft Sans Serif', 9, 
      System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.ldetail.ForeColor := System.Drawing.Color.Brown;
  Self.ldetail.Location := System.Drawing.Point.Create(16, 0);
  Self.ldetail.Name := 'ldetail';
  Self.ldetail.Size := System.Drawing.Size.Create(168, 16);
  Self.ldetail.TabIndex := 0;
  Self.ldetail.Text := 'detail';
  Self.ldetail.TextAlign := System.Drawing.ContentAlignment.MiddleCenter;
  // 
  // OleDbConnection1
  // 
  Self.OleDbConnection1.ConnectionString := 'Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\work_Delphinet\data\work_Delphi'+ 
  'net.mdb;Persist Security Info=False';
  // 
  // Panelinter
  // 
  Self.Panelinter.BackColor := System.Drawing.SystemColors.ControlDark;
  Self.Panelinter.Location := System.Drawing.Point.Create(416, 24);
  Self.Panelinter.Name := 'Panelinter';
  Self.Panelinter.Size := System.Drawing.Size.Create(8, 40);
  Self.Panelinter.TabIndex := 57;
  // 
  // ImageList1
  // 
  Self.ImageList1.ImageSize := System.Drawing.Size.Create(15, 15);
  Self.ImageList1.ImageStream := (System.Windows.Forms.ImageListStreamer(resources.GetObject('ImageList1.ImageStream')));
  Self.ImageList1.TransparentColor := System.Drawing.Color.Transparent;
  // 
  // Paneldata
  // 
  Self.Paneldata.BackColor := System.Drawing.SystemColors.ControlDark;
  Self.Paneldata.Controls.Add(Self.txtname);
  Self.Paneldata.Controls.Add(Self.txtfirst_father);
  Self.Paneldata.Controls.Add(Self.cmbbookid);
  Self.Paneldata.Controls.Add(Self.txtbookid);
  Self.Paneldata.Controls.Add(Self.Btndetail);
  Self.Paneldata.Controls.Add(Self.cmbfirst_father);
  Self.Paneldata.Controls.Add(Self.lfirst);
  Self.Paneldata.Controls.Add(Self.lname);
  Self.Paneldata.Controls.Add(Self.cmbname);
  Self.Paneldata.Location := System.Drawing.Point.Create(200, 8);
  Self.Paneldata.Name := 'Paneldata';
  Self.Paneldata.Size := System.Drawing.Size.Create(216, 74);
  Self.Paneldata.TabIndex := 54;
  // 
  // txtname
  // 
  Self.txtname.AutoSize := False;
  Self.txtname.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.txtname.Location := System.Drawing.Point.Create(88, 4);
  Self.txtname.Name := 'txtname';
  Self.txtname.ReadOnly := True;
  Self.txtname.Size := System.Drawing.Size.Create(96, 20);
  Self.txtname.TabIndex := 50;
  Self.txtname.Text := '';
  // 
  // txtfirst_father
  // 
  Self.txtfirst_father.AutoSize := False;
  Self.txtfirst_father.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.txtfirst_father.Location := System.Drawing.Point.Create(88, 28);
  Self.txtfirst_father.Name := 'txtfirst_father';
  Self.txtfirst_father.ReadOnly := True;
  Self.txtfirst_father.Size := System.Drawing.Size.Create(96, 20);
  Self.txtfirst_father.TabIndex := 49;
  Self.txtfirst_father.Text := '';
  // 
  // cmbbookid
  // 
  Self.cmbbookid.Location := System.Drawing.Point.Create(40, 48);
  Self.cmbbookid.Name := 'cmbbookid';
  Self.cmbbookid.Size := System.Drawing.Size.Create(32, 21);
  Self.cmbbookid.TabIndex := 48;
  Self.cmbbookid.Visible := False;
  // 
  // txtbookid
  // 
  Self.txtbookid.BorderStyle := System.Windows.Forms.BorderStyle.None;
  Self.txtbookid.Location := System.Drawing.Point.Create(8, 56);
  Self.txtbookid.Name := 'txtbookid';
  Self.txtbookid.Size := System.Drawing.Size.Create(24, 13);
  Self.txtbookid.TabIndex := 47;
  Self.txtbookid.Text := '';
  Self.txtbookid.Visible := False;
  // 
  // Btndetail
  // 
  Self.Btndetail.BackColor := System.Drawing.SystemColors.Control;
  Self.Btndetail.Location := System.Drawing.Point.Create(152, 54);
  Self.Btndetail.Name := 'Btndetail';
  Self.Btndetail.Size := System.Drawing.Size.Create(48, 16);
  Self.Btndetail.TabIndex := 46;
  Self.Btndetail.Text := 'detail';
  Include(Self.Btndetail.Click, Self.Btndetail_Click);
  // 
  // cmbfirst_father
  // 
  Self.cmbfirst_father.Location := System.Drawing.Point.Create(88, 28);
  Self.cmbfirst_father.Name := 'cmbfirst_father';
  Self.cmbfirst_father.Size := System.Drawing.Size.Create(120, 21);
  Self.cmbfirst_father.TabIndex := 45;
  Include(Self.cmbfirst_father.SelectedIndexChanged, Self.cmbfirst_father_SelectedIndexChanged);
  // 
  // lfirst
  // 
  Self.lfirst.Font := System.Drawing.Font.Create('Times New Roman', 8.25, System.Drawing.FontStyle.Regular, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lfirst.Location := System.Drawing.Point.Create(-8, 28);
  Self.lfirst.Name := 'lfirst';
  Self.lfirst.Size := System.Drawing.Size.Create(88, 16);
  Self.lfirst.TabIndex := 44;
  Self.lfirst.Text := 'first and father :';
  Self.lfirst.TextAlign := System.Drawing.ContentAlignment.MiddleRight;
  // 
  // lname
  // 
  Self.lname.Font := System.Drawing.Font.Create('Times New Roman', 8.25, System.Drawing.FontStyle.Regular, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.lname.Location := System.Drawing.Point.Create(16, 4);
  Self.lname.Name := 'lname';
  Self.lname.Size := System.Drawing.Size.Create(64, 16);
  Self.lname.TabIndex := 43;
  Self.lname.Text := 'name :';
  Self.lname.TextAlign := System.Drawing.ContentAlignment.MiddleRight;
  // 
  // cmbname
  // 
  Self.cmbname.Location := System.Drawing.Point.Create(88, 4);
  Self.cmbname.Name := 'cmbname';
  Self.cmbname.Size := System.Drawing.Size.Create(120, 21);
  Self.cmbname.TabIndex := 42;
  Include(Self.cmbname.SelectedIndexChanged, Self.cmbname_SelectedIndexChanged);
  // 
  // txttime
  // 
  Self.txttime.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.txttime.Location := System.Drawing.Point.Create(72, 40);
  Self.txttime.Name := 'txttime';
  Self.txttime.ReadOnly := True;
  Self.txttime.Size := System.Drawing.Size.Create(112, 20);
  Self.txttime.TabIndex := 53;
  Self.txttime.Text := '';
  // 
  // txtdescription
  // 
  Self.txtdescription.BorderStyle := System.Windows.Forms.BorderStyle.FixedSingle;
  Self.txtdescription.Location := System.Drawing.Point.Create(8, 88);
  Self.txtdescription.Multiline := True;
  Self.txtdescription.Name := 'txtdescription';
  Self.txtdescription.Size := System.Drawing.Size.Create(408, 84);
  Self.txtdescription.TabIndex := 46;
  Self.txtdescription.Text := '';
  Include(Self.txtdescription.KeyPress, Self.txtdescription_KeyPress);
  // 
  // ltime
  // 
  Self.ltime.Font := System.Drawing.Font.Create('Times New Roman', 8.25, System.Drawing.FontStyle.Regular, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.ltime.Location := System.Drawing.Point.Create(-8, 40);
  Self.ltime.Name := 'ltime';
  Self.ltime.Size := System.Drawing.Size.Create(72, 16);
  Self.ltime.TabIndex := 52;
  Self.ltime.Text := 'time :';
  Self.ltime.TextAlign := System.Drawing.ContentAlignment.MiddleRight;
  // 
  // ldate
  // 
  Self.ldate.Font := System.Drawing.Font.Create('Times New Roman', 8.25, System.Drawing.FontStyle.Regular, 
      System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.ldate.Location := System.Drawing.Point.Create(-8, 16);
  Self.ldate.Name := 'ldate';
  Self.ldate.Size := System.Drawing.Size.Create(72, 16);
  Self.ldate.TabIndex := 51;
  Self.ldate.Text := 'date :';
  Self.ldate.TextAlign := System.Drawing.ContentAlignment.MiddleRight;
  // 
  // ImageList2
  // 
  Self.ImageList2.ImageSize := System.Drawing.Size.Create(65, 20);
  Self.ImageList2.ImageStream := (System.Windows.Forms.ImageListStreamer(resources.GetObject('ImageList2.ImageStream')));
  Self.ImageList2.TransparentColor := System.Drawing.Color.Transparent;
  // 
  // DateTimePicker1
  // 
  Self.DateTimePicker1.CustomFormat := 'M/d/yyyy';
  Self.DateTimePicker1.Format := System.Windows.Forms.DateTimePickerFormat.Short;
  Self.DateTimePicker1.Location := System.Drawing.Point.Create(72, 16);
  Self.DateTimePicker1.Name := 'DateTimePicker1';
  Self.DateTimePicker1.Size := System.Drawing.Size.Create(112, 20);
  Self.DateTimePicker1.TabIndex := 50;
  // 
  // ldescription
  // 
  Self.ldescription.Font := System.Drawing.Font.Create('Times New Roman', 8.25, 
      System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, (Byte(178)));
  Self.ldescription.Location := System.Drawing.Point.Create(8, 64);
  Self.ldescription.Name := 'ldescription';
  Self.ldescription.Size := System.Drawing.Size.Create(72, 16);
  Self.ldescription.TabIndex := 47;
  Self.ldescription.Text := 'description ';
  Self.ldescription.TextAlign := System.Drawing.ContentAlignment.MiddleLeft;
  // 
  // btn_cancel
  // 
  Self.btn_cancel.ImageIndex := 1;
  Self.btn_cancel.ImageList := Self.ImageList2;
  Self.btn_cancel.Location := System.Drawing.Point.Create(352, 176);
  Self.btn_cancel.Name := 'btn_cancel';
  Self.btn_cancel.Size := System.Drawing.Size.Create(65, 20);
  Self.btn_cancel.TabIndex := 49;
  Include(Self.btn_cancel.Click, Self.btn_cancel_Click);
  // 
  // btn_ok
  // 
  Self.btn_ok.ImageIndex := 0;
  Self.btn_ok.ImageList := Self.ImageList2;
  Self.btn_ok.Location := System.Drawing.Point.Create(272, 176);
  Self.btn_ok.Name := 'btn_ok';
  Self.btn_ok.Size := System.Drawing.Size.Create(65, 20);
  Self.btn_ok.TabIndex := 48;
  Include(Self.btn_ok.Click, Self.btn_ok_Click);
  // 
  // Btntime
  // 
  Self.Btntime.ImageIndex := 0;
  Self.Btntime.ImageList := Self.ImageList1;
  Self.Btntime.Location := System.Drawing.Point.Create(168, 40);
  Self.Btntime.Name := 'Btntime';
  Self.Btntime.Size := System.Drawing.Size.Create(15, 15);
  Self.Btntime.TabIndex := 58;
  Include(Self.Btntime.Click, Self.Btntime_Click);
  // 
  // Tagenda_appoint
  // 
  Self.AutoScaleBaseSize := System.Drawing.Size.Create(5, 13);
  Self.ClientSize := System.Drawing.Size.Create(634, 200);
  Self.Controls.Add(Self.Btntime);
  Self.Controls.Add(Self.txttime);
  Self.Controls.Add(Self.txtdescription);
  Self.Controls.Add(Self.ltime);
  Self.Controls.Add(Self.ldate);
  Self.Controls.Add(Self.DateTimePicker1);
  Self.Controls.Add(Self.ldescription);
  Self.Controls.Add(Self.btn_cancel);
  Self.Controls.Add(Self.btn_ok);
  Self.Controls.Add(Self.Paneldetail);
  Self.Controls.Add(Self.Panelinter);
  Self.Controls.Add(Self.Paneldata);
  Self.FormBorderStyle := System.Windows.Forms.FormBorderStyle.FixedSingle;
  Self.MaximizeBox := False;
  Self.MinimizeBox := False;
  Self.Name := 'Tagenda_appoint';
  Self.StartPosition := System.Windows.Forms.FormStartPosition.CenterScreen;
  Self.Text := 'Agenda appointment';
  Include(Self.Load, Self.Tagenda_appoint_Load);
  Include(Self.Activated, Self.Tagenda_appoint_Activated);
  Self.Paneldetail.ResumeLayout(False);
  Self.Paneldata.ResumeLayout(False);
  Self.ResumeLayout(False);
end;
{$ENDREGION}

procedure Tagenda_appoint.Dispose(Disposing: Boolean);
begin
  if Disposing then
  begin
    if Components <> nil then
      Components.Dispose();
  end;
  inherited Dispose(Disposing);
end;

constructor Tagenda_appoint.Create;
begin
  inherited Create;
  //
  // Required for Windows Form Designer support
  //
  InitializeComponent;
  //
  // TODO: Add any constructor code after InitializeComponent call
  //
 Self.Btntime.Top := Self.txttime.Top + ((Self.txttime.Height - Self.Btntime.Height) div 2);

	 Self.Width := Self.txtdescription.Left + Self.txtdescription.Width + (7 * Self.Panelinter.Width div 4);
	 Self.Paneldata.BackColor := Self.BackColor;
	 Self.Panelinter.BackColor := Self.BackColor;
	 Self.Btn_cancel.Left := (Self.txtdescription.Left + Self.txtdescription.Width) - Self.Btn_cancel.Width;
	 Self.Btndetail.Left := (Self.cmbfirst_father.Left + Self.cmbfirst_father.Width) - Self.Btndetail.Width;

   v_appoint_left := Self.Width;
   v_appoint_Top := Self.Height;
   v_appoint_txttimeLeft := Self.txttime.Left;
   v_appoint_txttimeTop := Self.txttime.Top;
   v_appoint_txttimeHeight := Self.txttime.Height;

end;

class function Tagenda_appoint.appoint_flag: Boolean;
begin
    result := v_appoint_flag;
 end;

class function Tagenda_appoint.appoint_agenda_desc: string;
begin
    result := v_appoint_agenda_desc;
 end;

class function Tagenda_appoint.appoint_agenda_time: string;
begin
    result := v_appoint_agenda_time;
 end;

class function Tagenda_appoint.appoint_agenda_date: System.DateTime;
begin
    result := v_appoint_agenda_date;
 end;

class function Tagenda_appoint.appoint_agenda_bookid: string;
begin
    result := v_appoint_agenda_bookid;
 end;

class function Tagenda_appoint.appoint_left: Integer;
begin
    result :=  v_appoint_left;
 end;

class function Tagenda_appoint.appoint_Top: Integer;
begin
    result := v_appoint_Top;
 end;

class function Tagenda_appoint.appointtxttime_Left: Integer;
begin
    result := v_appoint_txttimeLeft;
 end;

class function Tagenda_appoint.appointtxttime_Top: Integer;
begin
    result := v_appoint_txttimeTop;
 end;

class function Tagenda_appoint.appointtxttime_Height: Integer;
begin
    result := v_appoint_txttimeHeight;
 end;

class function Tagenda_appoint.Showagenda_appoint: System.Windows.Forms.DialogResult;
begin
  with Tagenda_appoint.Create do
    Result := ShowDialog;
end;
procedure Tagenda_appoint.Tagenda_appoint_Load(sender: System.Object; e: System.EventArgs);
begin
      Self.Btndetail.Text := 'detail';
      v_appoint_flag := False;
      time_flag := False;
			//new appointment & edit appointment
			if (agenda.Tagenda.agenda_appoint_type = 'edit') then
			begin
					Self.Text := 'edit appointment';
					Self.txtdescription.Text := agenda.Tagenda.agenda_desc;
					Self.DateTimePicker1.Value := agenda.Tagenda.agenda_appoint_date;
				 	Self.txttime.Text := agenda.Tagenda.agenda_appoint_time;
					Self.Btn_ok.Enabled := False;
					sub_info(False);
			end;

      if (agenda.Tagenda.agenda_appoint_type = 'task_appoint') then
			begin
					//fagenda_task.Close();
					Self.Text := 'new appointment - task moved ...';
					Self.txtdescription.Text := agenda.Tagenda.agenda_desc;
					Self.DateTimePicker1.Value := agenda.Tagenda.agenda_appoint_date;
					sub_nullovalue();
			end;

      if (agenda.Tagenda.agenda_appoint_type = 'new') then
			begin
					Self.Text := 'new appointment';
					Self.DateTimePicker1.Value := agenda.Tagenda.agenda_appoint_date;
					Self.txtdescription.Text := '';

					sub_nullovalue();

					if (agenda.Tagenda.appoint_full = True) then
					begin
						//with this current date, add new appointmement not available
						MessageBox.Show('note: to add new appointment, change the current date - ' + System.Convert.ToString(agenda.Tagenda.agenda_appoint_date.Month) + '/' + System.Convert.ToString(agenda.Tagenda.agenda_appoint_date.Day) + '/' + System.Convert.ToString(agenda.Tagenda.agenda_appoint_date.Year) + '    ', mainform.Tmainform.Title, MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Information);
					end;
			end;

end;

procedure Tagenda_appoint.sub_nullovalue;
begin
			Self.cmbname.Items.Clear();
			Self.cmbfirst_father.Items.Clear();
			Self.cmbname.Text := '';
			Self.cmbfirst_father.Text := '';
			Self.txttime.Text := '';
			v_appoint_agenda_time := '';
			Self.txtname.Text := '';
			Self.txtfirst_father.Text := '';
			Self.Btn_ok.Enabled := False;
		 	sub_info(True);
			Self.Btndetail.Enabled := False;
end;

procedure Tagenda_appoint.sub_info(bval: Boolean);
begin
			Self.cmbname.Visible := bval;
			Self.cmbfirst_father.Visible := bval;
     	Self.txtname.Visible := not bval;
			Self.txtfirst_father.Visible := not bval;
			Self.txtname.Width := Self.cmbname.Width;
			Self.txtfirst_father.Width := Self.cmbfirst_father.Width;

			if (agenda.Tagenda.agenda_appoint_type = 'task_appoint') then
			begin
					sub_load('name', '');
					Self.cmbfirst_father.Enabled := False;
          exit
      end;
			if (agenda.Tagenda.agenda_appoint_type = 'new') then
			begin
					sub_load('name', '');
					Self.cmbfirst_father.Enabled := False;
          exit
      end;
			if (agenda.Tagenda.agenda_appoint_type = 'edit') then
			begin
					Self.txtbookid.Text := agenda.Tagenda.agenda_appoint_bookid;
					//load value corresponding to editbookid.Text
					sub_load('detail', Self.txtbookid.Text.Trim());
					if (agenda.Tagenda.agenda_appoint_bookid.Trim().Length > 0 ) then
						Self.Btndetail.Enabled := True;
          exit
			end;
end;

//book table, add data to comboboxes and detail information
procedure Tagenda_appoint.sub_load(v_field: string; v_fieldname: string);
var
i: Integer;
begin
    vselect := System.Data.OleDb.OleDbCommand.Create;
    vda := System.Data.OleDb.OleDbDataAdapter.Create;
    vdset := System.Data.DataSet.Create;

     if (v_field = 'name') then
					vselect.CommandText := 'SELECT DISTINCT Trim(name) AS vname FROM book WHERE (Trim(name) <> "") ORDER BY Trim(name)';
		 if (v_field = 'first') then
		 		vselect.CommandText := 'SELECT bookid, name, first_name, father_name FROM book WHERE (name = "' + v_fieldname + '") ORDER BY first_name, father_name';
		 if (v_field = 'detail') then
       	vselect.CommandText := 'SELECT bookid, city, civil_status, country, email, father_name, first_name, homephone, mobilephone, name, sex, web, workphone FROM book WHERE (bookid = '+ v_fieldname + ')';

    vselect.Connection := Self.OleDbConnection1;
    vda.SelectCommand := vselect;
    vdset.EnforceConstraints := False;

    Try
      //Open the connection.
      Self.OleDbConnection1.Open();
      vda.Fill(vdset, 'book');
    finally
       //Turn constraint checking back on.
       vdset.EnforceConstraints := True;
       //Close the connection
       Self.OleDbConnection1.Close();
    end;

    	if (vdset.Tables['book'].Rows.Count > 0) then
			begin
				for i := 0 to (vdset.Tables['book'].Rows.Count - 1) do
				begin

					if ( v_field = 'name') then
					begin
          		Self.cmbname.Items.Add(vdset.Tables['book'].Rows[i].Item['vname'].ToString().Trim());

				  end;

					if ( v_field = 'first') then
          begin
							Self.cmbfirst_father.Items.Add(vdset.Tables['book'].Rows[i].Item['first_name'].ToString().Trim() + ' ' + vdset.Tables['book'].Rows[i].Item['father_name'].ToString().Trim());
							Self.cmbbookid.Items.Add(System.Convert.ToString(vdset.Tables['book'].Rows[i].Item['bookid']));

			 		end;
          if ( v_field = 'detail') then
				 	begin
					 		Self.l_name.Text := vdset.Tables['book'].Rows[i].Item['name'].ToString().Trim();
				 			if (vdset.Tables['book'].Rows[i].Item['first_name'].ToString().Trim().Length = 0) then
								Self.l_first.Text := ' ... '
							else
				 				Self.l_first.Text := vdset.Tables['book'].Rows[i].Item['first_name'].ToString().Trim();

							if (vdset.Tables['book'].Rows[i].Item['father_name'].ToString().Trim().Length = 0) then
			 						Self.l_father.Text := ' ... '
							else
			 					Self.l_father.Text := vdset.Tables['book'].Rows[i].Item['father_name'].ToString().Trim();

							if (vdset.Tables['book'].Rows[i].Item['city'].ToString().Trim().Length = 0) then
								Self.l_city.Text := ' ... '
			 				else
			 					Self.l_city.Text := vdset.Tables['book'].Rows[i].Item['city'].ToString().Trim();

				 			if (vdset.Tables['book'].Rows[i].Item['homephone'].ToString().Trim().Length = 0) then
								Self.l_phone.Text := ' ... '
					 		else
					 			Self.l_phone.Text := vdset.Tables['book'].Rows[i].Item['homephone'].ToString().Trim();

							if (vdset.Tables['book'].Rows[i].Item['mobilephone'].ToString().Trim().Length = 0) then
					 			Self.l_mobile.Text := ' ... '
							else
				 				Self.l_mobile.Text := vdset.Tables['book'].Rows[i].Item['mobilephone'].ToString().Trim();

							if (vdset.Tables['book'].Rows[i].Item['email'].ToString().Trim().Length = 0) then
								Self.l_email.Text := ' ... '
				 			else
								Self.l_email.Text := vdset.Tables['book'].Rows[i].Item['email'].ToString().Trim();
          end;

					if (agenda.Tagenda.agenda_appoint_type = 'edit') then
					begin
						Self.txtname.Text := Self.l_name.Text;
						Self.txtfirst_father.Text := Self.l_first.Text + ' ' + Self.l_father.Text;

            exit;
					end;
				end;
			end;
end;

procedure Tagenda_appoint.cmbname_SelectedIndexChanged(sender: System.Object;
  e: System.EventArgs);
begin
     sub_load('first', Self.cmbname.Text);
			Self.cmbfirst_father.Enabled := True;
end;

procedure Tagenda_appoint.cmbfirst_father_SelectedIndexChanged(sender: System.Object;
  e: System.EventArgs);
begin
      Self.txtname.Text := Self.cmbname.Text;
			Self.txtfirst_father.Text := Self.cmbfirst_father.Text;
			Self.cmbbookid.SelectedIndex := Self.cmbfirst_father.SelectedIndex;
			Self.txtbookid.Text := Self.cmbbookid.Text;
			sub_load('detail', Self.txtbookid.Text.Trim());
			Self.Btndetail.Enabled := True;
end;

//from book table, detail information
procedure Tagenda_appoint.Btndetail_Click(sender: System.Object; e: System.EventArgs);
begin
    if (Self.Btndetail.Text = 'detail') then
			begin
				Self.Width := 2 * Self.txtdescription.Left + Self.txtdescription.Width + Self.Paneldetail.Width + 7 * Self.Panelinter.Width  div 4;
				Self.Paneldata.BackColor := Self.Paneldetail.BackColor;
				Self.Panelinter.BackColor := Self.Paneldetail.BackColor;

				Self.Btndetail.Text := 'hide';
				exit;
			end;
			if (Self.Btndetail.Text = 'hide') then
			begin
				Self.Width := Self.txtdescription.Left + Self.txtdescription.Width + 7 * Self.Panelinter.Width div 4;
				Self.Paneldata.BackColor := Self.BackColor;
				Self.Panelinter.BackColor := Self.BackColor;

				Self.Btndetail.Text := 'detail';
			end;
end;

//agenda_time form, show
procedure Tagenda_appoint.Btntime_Click(sender: System.Object; e: System.EventArgs);
begin
    time_flag := true;
    agenda_time.Tagenda_time.Showagenda_time;
end;

procedure Tagenda_appoint.txtdescription_KeyPress(sender: System.Object; e: System.Windows.Forms.KeyPressEventArgs);
begin
    Self.Btn_ok.Enabled := true;
end;

procedure Tagenda_appoint.Tagenda_appoint_Activated(sender: System.Object; e: System.EventArgs);
begin
    if ((agenda_time.Tagenda_time.time_flag = true) And (time_flag = true)) then
    sub_timeok();
end;

procedure Tagenda_appoint.sub_timeok;
		begin
			if (agenda_time.Tagenda_time.time_flag = True) then
			begin
				Self.txttime.Text := agenda_time.Tagenda_time.appoint_time;
				Self.Btn_ok.Enabled := True;
			end;
		end;


procedure Tagenda_appoint.btn_ok_Click(sender: System.Object; e: System.EventArgs);
begin
    if ((Self.txtdescription.Text.Trim().Length > 0) And (Self.txttime.Text.Trim().Length > 0)) then
			begin
				if ((Self.txtname.Text.Trim().Length > 0) And (Self.txtfirst_father.Text.Trim().Length > 0)) then
				begin
					sub_Btn_ok();
					exit;
				end
				else
				begin
					MessageBox.Show('name value or first and father value, empty ... not available', mainform.Tmainform.Title, MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Information);
					exit;
				end;
			end
			else
			begin
				MessageBox.Show('description value or time value, empty ... not available', mainform.Tmainform.Title, MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Information);
				exit;
			end;
end;

procedure Tagenda_appoint.sub_Btn_ok;
 var
 response: System.Windows.Forms.DialogResult;
begin

			if (agenda.Tagenda.agenda_appoint_type = 'task_appoint') then
			begin
					sub_Full('A', Self.DateTimePicker1.Value);
					if ((vdset.Tables['agenda'].Rows.Count - 1) >= 24) then
					begin
						response := MessageBox.Show('to save the current appointment ..., change the current date - ' + System.Convert.ToString(agenda.Tagenda.agenda_appoint_date.Month) + '/' + System.Convert.ToString(agenda.Tagenda.agenda_appoint_date.Day) + '/' + System.Convert.ToString(agenda.Tagenda.agenda_appoint_date.Year) + '    ', mainform.Tmainform.Title, MessageBoxButtons.YesNo, System.Windows.Forms.MessageBoxIcon.Information);
						if (response = System.Windows.Forms.DialogResult.Yes) then
							exit;
						if (response = System.Windows.Forms.DialogResult.No) then
						begin
							sub_cancel();
							exit;
						end;
					end
			    else
			    begin
						v_appoint_flag := true;
            v_appoint_agenda_desc := Self.txtdescription.Text;
						v_appoint_agenda_date := Self.DateTimePicker1.Value;
            v_appoint_agenda_time := Self.txttime.Text;
						v_appoint_agenda_bookid := Self.txtbookid.Text;
						Self.Close();
						agenda.Tagenda.ActiveForm.Refresh();
						agenda.Tagenda.ActiveForm.Activate();
			    end;
			end;

			if (agenda.Tagenda.agenda_appoint_type = 'new') then
			begin
					sub_Full('A', Self.DateTimePicker1.Value);
					if ((vdset.Tables['agenda'].Rows.Count - 1) >= 24) then
					begin
						//with this current date, add new appointmement not available
						response := MessageBox.Show('to save this appointment, change the current date - ' + System.Convert.ToString(agenda.Tagenda.agenda_appoint_date.Month) + '/' + System.Convert.ToString(agenda.Tagenda.agenda_appoint_date.Day) + '/' + System.Convert.ToString(agenda.Tagenda.agenda_appoint_date.Year) + '    ', mainform.Tmainform.Title, MessageBoxButtons.YesNo, System.Windows.Forms.MessageBoxIcon.Information);
						if (response = System.Windows.Forms.DialogResult.Yes) then
							exit;
						if (response = System.Windows.Forms.DialogResult.No) then
						begin
							sub_cancel();
							exit;
						end;
					end
					else
					begin
						v_appoint_flag := True;
						v_appoint_agenda_desc := Self.txtdescription.Text;
						v_appoint_agenda_date := Self.DateTimePicker1.Value;
            v_appoint_agenda_time := Self.txttime.Text;
						v_appoint_agenda_bookid := Self.txtbookid.Text;
						Self.Close();
						agenda.Tagenda.ActiveForm.Refresh();
						agenda.Tagenda.ActiveForm.Activate();
					end;
				end;

			if (agenda.Tagenda.agenda_appoint_type = 'edit') then
			begin
					v_appoint_flag := True;
					v_appoint_agenda_desc := Self.txtdescription.Text;
					v_appoint_agenda_date := Self.DateTimePicker1.Value;
          v_appoint_agenda_time := Self.txttime.Text;
					Self.Close();
					agenda.Tagenda.ActiveForm.Refresh();
					agenda.Tagenda.ActiveForm.Activate();
			end;

end;

procedure Tagenda_appoint.sub_Full(v_entry_type: string ; v_date: System.DateTime);
var
strdate_d: string;
strdate_m: string;
strdate_y: string;
begin
      vselect := System.Data.OleDb.OleDbCommand.Create;
      vda := System.Data.OleDb.OleDbDataAdapter.Create;
      vdset := System.Data.DataSet.Create;
      
			strdate_d := System.Convert.ToString(v_date.Day);
			strdate_m := System.Convert.ToString(v_date.Month);
			strdate_y := System.Convert.ToString(v_date.Year);

			vselect.CommandText := 'SELECT entry_type, ondate, ondate_d, ondate_m, ondate_y FROM agenda WHERE (entry_type = "' + v_entry_type + '") AND (ondate_d = "' + strdate_d + '") AND (ondate_m = "' + strdate_m + '") AND (ondate_y = "' + strdate_y + '") ORDER BY serialno';
		  vselect.Connection := Self.OleDbConnection1;
      vda.SelectCommand := vselect;
      vdset.EnforceConstraints := False;
      Try
        //Open the connection.
        Self.OleDbConnection1.Open();
        vda.Fill(vdset, 'agenda');
      finally
       //Turn constraint checking back on.
       vdset.EnforceConstraints := True;
       //Close the connection
       Self.OleDbConnection1.Close();
      end;

end;
 
procedure Tagenda_appoint.btn_cancel_Click(sender: System.Object; e: System.EventArgs);
begin
     sub_cancel();
end;

procedure Tagenda_appoint.sub_cancel;
		begin
			v_appoint_flag := False;
			v_appoint_agenda_desc := '';
      v_appoint_agenda_time := '';
			Self.Close();
			agenda.Tagenda.ActiveForm.Refresh();
			agenda.Tagenda.ActiveForm.Activate();
		end;



end.
